#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define n1 4								/* n1>=n+1, nϹAμ */
int CHLdecomp(int n,double eps,double a[][n1]){
/*  :  쥹ʬоιA򥳥쥹ʬ򤹤        */
/*     n:  int             θ                           */
/*   eps:  double          Ƚ                         */
/*     a:  double[][]    Aβa[1:n][1:n]         */
/*                                       AΥ쥹ʬ        */
/*     j:  int             λ  j=0:                     */
/*                                       j>0:۾A͡      */
	int i,j,k;
	for(j=1;j<=n;j++){
		for(k=1;k<j;k++){					/* a[j][j]=l[j][j]^2 */
			a[j][j]-=a[j][k]*a[j][k];
			}
		if(a[j][j]<eps){					/* Ƚ */
			return j;						/* ۾ｪλ */
			}
		a[j][j]=sqrt(a[j][j]);				/* a[j][j]=l[j][j] */
		for(i=j+1;i<=n;i++){				/* (13) */
			for(k=1;k<j;k++){
				a[i][j]-=a[i][k]*a[j][k];
				}
			a[i][j] /=a[j][j];				/* a[i][j]=l[i][j] */
			}
		}
	return 0;								/* ｪλ */
	}
int CHLsolve(double a[][n1], int n, double b[]){
/*  :  쥹AΥ쥹ʬη̤ѤAx=b    */
/*     a:  double[][]      CHLdecompν                        */
/*                             AΥ쥹ʬ                  */
/*     n:  int             θ                           */
/*     b:  double[]      ե٥ȥb٥ȥx           */
	int i,j;
	for(i=1;i<=n;i++){						/*  */
		for(j=1;j<i;j++)b[i]-=a[i][j]*b[j];
		b[i] /=a[i][i];
		}
	for(i=n;i>=1;i--){						/*  */
		for(j=i+1;j<=n;j++)b[i]-=a[j][i]*b[j];
		b[i] /=a[i][i];
		}
	return 0;
	}       
int main(){
	double a[n1][n1]={{0,0,0,0},{0,3,0,0},{0,1,3,0},{0,1,1,3}};
	double b[n1]={0,5,5,5},eps=1.0e-15;
	int i,n,cnd;
	n=n1-1;									/* Aμn */
	cnd=CHLdecomp(n,eps,a);
	printf("cnd=%d\n",cnd);
	CHLsolve(a,n,b);
	for(i=1;i<=n;i++){
		printf("b[%2d]=%10.7f, error=%9.2e\n",i,b[i],b[i]-1);
		}
	return 0;
	}
