#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define m1 201								/* m1>=m+1, mϹA */
#define n1 101								/* n1>=n+1, nϹA */
#define Max(a,b) (a>b ? a:b)				/* Max(a,b)=max{a,b} */
int HQRdecomp(int m,int n,double eps,double a[][n1],double d[]){
/*  :  QRʬ򡥹AϥۥˡQRʬ򤹤                */
/*     m:  int             AιԿ                                */
/*     n:  int             A,m>=n                           */
/*   eps:  double          §Ƚ                         */
/*     a:  double[][]    Aa[1:n][1:n]                     */
/*                                          AQRʬA=QR         */
/*     d:  double[]        Rгd[1:n]˳Ǽ          */
/*     k:  int*            λ  k=0:                     */
/*                                       k>0:۾rankA<n          */
	double r,s,p;
	int i,j,k;
	for(k=1;k<=n;k++){							/* u^(k)η׻ */
		s=0;									/* kΥ */
		for(i=k;i<=m;i++){
			s+=a[i][k]*a[i][k];
			}
		s=sqrt(s);
		if(s<eps){								/* Ƚ */
			return k;							/* ۾ｪλ */
			}
		d[k]=(a[k][k]>0)? -s:s;					/* d[k] */
		r=1/sqrt(d[k]*(d[k]-a[k][k]));
		a[k][k]=(a[k][k]-d[k])*r;
		for(i=k+1;i<=m;i++){					/* u^(k) */
			a[i][k]*=r;
			}
		for(j=k+1;j<=n;j++){					/* H(u^(k))W^(k) */
			p=0;								/*  */
			for(i=k;i<=m;i++){
				p+=a[i][j]*a[i][k];
				}
			for(i=k;i<=m;i++){					/* Ѵ */
				a[i][j]-=p*a[i][k];
				}
			}
		}
	return 0;									/* ｪλ */
	}
int HQRsolve(double a[][n1],double d[],int m,int n,double b[]){
/*  :  QRAQRʬη̤ѤǾ2Ax=b         */
/*     a:  double[][]      HQRdecompνϡAQRʬ           */
/*     m:  int             AιԿ                                */
/*     n:  int             A,m>=n                           */
/*     b:  double[]      ե٥ȥb٥ȥx           */
	double p;
	int i,j,k;
	for(k=1;k<=n;k++){					/* ϥۥѴ */
		p=0;							/*  */
		for(i=k;i<=m;i++){
			p+=b[i]*a[i][k];
			}
		for(i=k;i<=m;i++){				/* õ */
		b[i]-=p*a[i][k];
			}
		}
	for(i=n;i>=1;i--){					/*  */
		for(j=i+1;j<=n;j++)b[i]-=a[i][j]*b[j];
		b[i]=b[i]/d[i];
		}
	return 0;
	}

int main(){
	double a[m1][n1],d[m1],b[m1],eps;
	int i,j,m,n,cnd;
	m=10;n=5;							/* AΥm,n */
	/* Aȱե٥ȥb */
	for(i=1;i<=m;i++){
		for(j=1;j<=n;j++){
				a[i][j]=Max(sin(i),cos(j));
			}
			b[i]=1;
		}
	/* ʲb[1:n] */
	eps=1.0e-14;
	cnd=HQRdecomp(m,n,eps,a,d);
	printf("cnd=%d\n",cnd);
	HQRsolve(a,d,m,n,b);
	for(i=1;i<=n;i++){
		printf("b[%2d]=%10.7f\n",i,b[i]);
		}
	return 0;
	}
