#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define n1 4							/* n1>=n+1, nϹAμ */
int LUdecomp(int n,double eps,double a[][n1],int pv[]){
/*  :  LUʬ§ALUʬ򤹤                              */
/*     n:  int             θ                           */
/*   eps:  double          Ƚ                         */
/*     a:  double[][]    Aa[1:n][1:n]ALUʬ        */
/*    pv:  int[]           ԥܥåֹpv[1:n]                    */
/*     k:  int             λ  k=0:                     */
/*                                       k>0:۾A§        */
	double temp;
	int i,j,k,p;
	for(k=1;k<=n;k++){							/* ʾõ */
		p=k;									/* ԥܥå */
		for(i=k+1;i<=n;i++){
			if(fabs(a[p][k])<fabs(a[i][k]))p=i;
			}
		if(fabs(a[p][k])<eps){					/* §Ƚ */
			return k;							/* ۾ｪλ */
			}
		pv[k]=p;								/* pεϿ */
		if(p!=k){
			for(j=k;j<=n;j++){					/* Ը */
				temp=a[k][j];a[k][j]=a[p][j];a[p][j]=temp;
				}
			}
		for(i=k+1;i<=n;i++){					/* õ */
			a[i][k]=a[i][k]/a[k][k];			/* rεϿ */
			for(j=k+1;j<=n;j++){
				a[i][j]-=a[i][k]*a[k][j];
				}
			}
		}
	return 0;									/* ｪλ */
	}
int LUsolve(double a[][n1], int n, int pv[], double b[]){
/*  :  LUALUʬη̤ѤAx=b                    */
/*     a:  double[][]      LUdecompνϡALUʬ            */
/*     n:  int             θ                           */
/*     b:  double[]      ե٥ȥb٥ȥx           */
	double temp;
	int i,j,k;
	for(k=1;k<n;k++){							/* ʾõ */
		temp=b[k];b[k]=b[pv[k]];b[pv[k]]=temp;	/* Ǹ */
		for(i=k+1;i<=n;i++){					/* õ */
			b[i]-=a[i][k]*b[k];
			}
		}
	for(i=n;i>=1;i--){							/*  */
		for(j=i+1;j<=n;j++)b[i]-=a[i][j]*b[j];
		b[i]=b[i]/a[i][i];
			}
	return 0;
	}
int main(){
	double a[n1][n1]={{0,0,0,0},{0,3,1,1},{0,1,3,1},{0,1,1,3}};
	double b[n1]={0,5,5,5},eps=1.0e-15;
	int i,n,pv[n1],cnd;
	n=n1-1;										/* Aμn */
	cnd=LUdecomp(n,eps,a,pv);
	printf("cnd=%d\n",cnd);
	LUsolve(a,n,pv,b);
	for(i=1;i<=n;i++){
		printf("b[%2d]=%10.7f, error=%9.2e\n",i,b[i],b[i]-1);
		}
	return 0;
	}
