#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define n1 101								/* n1?n+1, nϹAμ */
#define Max(a,b) (a>b ? a:b)				/* Max(a,b)=max{a,b} */
/*  InnerP(x,y,n):٥ȥx,y */
double InnerP(double x[],double y[],int n){
/*    :  ѡ٥ȥx,yp=(x,y)׻                     */
/*       x:  double[]    ٥ȥxx[1:n]                    */
/*       y:  double[]    ٥ȥyy[1:n]                    */
/*       n:  int         ٥ȥμ                           */
/*       p:  double      p=(x,y)                              */
	double p=0;int i;
	for(i=1;i<=n;i++)p+=x[i]*y[i];
	return p;
	}
int PowM(double a[][n1],int n,double eps,int kmax,double x[]
	,double *lambda){
/*    :  ߾ˡоιA                                      */
/*               ͺθͭlambdaȸͭ٥ȥx׻        */
/*       a:  double[][]      Aa[1:n][1:n]                   */
/*       n:  int             Aμ                              */
/*     eps:  double          «Ƚ                         */
/*    kmax:  int             ȿ                         */
/*       x:  double[]      ٥ȥx[1:n]                   */
/*                                      ͭ٥ȥx[1:n]        */
/*  lambda:  double*         ͭ                               */
/*    PowM:  int             ȿ                             */
	double v[n1],nx,p,lm,r,ri;
	int i,k;
	nx=1/sqrt(InnerP(x,x,n));
	for(i=1;i<=n;i++)x[i]*=nx;			/* ٥ȥx */
	k=0;
	do{									/* ߾ˡ */
		for(i=1;i<=n;i++){				/* v=Ax */
			v[i]=InnerP(a[i],x,n);
			}
		p=InnerP(v,v,n);				/* p=(v,v) */
		lm=InnerP(v,x,n);				/* lm=(v,x) */
		r=0;nx=1/sqrt(p);
		for(i=1;i<=n;i++){				/* ĺΥ2rˤxι */
			ri=v[i]-lm*x[i];
			r+=ri*ri;
			x[i]=v[i]*nx;
		};
		k++;
		}while(r>eps*eps && k<kmax);	/* «ȽꡦæȽ */
	*lambda=lm;
	return k;
	}
int main () {
	double a[n1][n1],lambda,x[n1], eps;
	int i,j,k,n,kmax;
	n=10;								/* Aμn<n1 */
	/* A٥ȥx٥ȥˤ */
	srand(1);							/* ؿrand()ν */
	for(i=1;i<=n;i++){
		for(j=1;j<=n;j++)a[i][j]=Max(i,j);
		x[i]=((double)rand()*2-1)/RAND_MAX;		/* [-1,1]ΰ */
		}
	/* ߾ˡ */
	eps=1.0e-5;kmax=100;
	k=PowM(a,n,eps,kmax,x,&lambda);
	printf("k=%d kmax=%d\n",k,kmax);    
	printf("lambda=%f\n",lambda);
	for(i=1;i<=n;i++){
		printf(" x[%2d]=%10.7f\n",i,x[i]);
		}
	return 0;
	}
