#include <stdio.h>
#include <stdlib.h>
#include <math.h>
double QuadM(double f(double),double a,double b,int m){
/*   :  §[a,b]δؿf(x)ʬ                     */
/*      f:  double(double)    ʬؿ                          */
/*      a:  double            ʬֲ                        */
/*      b:  double            ʬ־                        */
/*      m:  int               ʬ                          */
/*  QuadM:  double            ʬ                              */
	double Mm,h,ci;
	int i;
	h=(b-a)/m;
	ci=a+h/2;
	Mm=0;
	for(i=0;i<m;i++){
		Mm +=f(ci);
		ci +=h;
		}
	return h*Mm;
	}
double QuadT(double f(double),double a,double b,int m){
/*   :  §[a,b]δؿf(x)ʬ                     */
/*      f:  double(double)    ʬؿ                          */
/*      a:  double            ʬֲ                        */
/*      b:  double            ʬ־                        */
/*      m:  int               ʬ                          */
/*  QuadT:  double            ʬ                              */
	double Tm,h,ai;
	int i;
	h=(b-a)/m;
	ai=a+h;
	Tm=(f(a)+f(b))/2;
	for(i=1;i<m;i++){
		Tm +=f(ai);
		ai +=h;
		}
	return h*Tm;
	}
double QuadS(double f(double),double a,double b,int m){
/*   :  ץ§[a,b]δؿf(x)ʬ               */
/*      f:  double(double)    ʬؿ                          */
/*      a:  double            ʬֲ                        */
/*      b:  double            ʬ־                        */
/*      m:  int               ʬ                          */
/*  QuadS:  double            ʬ                              */
	double Mm,Tm;
	Mm=QuadM(f,a,b,m);
	Tm=QuadT(f,a,b,m);
	return (2*Mm+Tm)/3;
	}
double f(double x){return sin(x);}		/* ʬؿf(x) */
int main(){
	double a,b,Mm,Tm,S2m,Itrue;
	int m=10;							/* ʬ */
	a=0;b=1;							/* ʬ[a,b] */
	Itrue=cos(a)-cos(b);				/* ʬ */
	Mm =QuadM(f,a,b,m);					/* §ˤʬ */
	Tm =QuadT(f,a,b,m);					/* §ˤʬ */
	S2m=QuadS(f,a,b,m);					/* ץ§ˤʬ */
	printf("m=%d\n",m);
	printf("Error of Mm =%9.2e\n",Mm-Itrue);
	printf("Error of Tm =%9.2e\n",Tm-Itrue);
	printf("Error of S2m=%9.2e\n",S2m-Itrue);
	return 0;
	}
