#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define n1 6								/* n1=n+1, nϹAμ */
#define Max(a,b) (a>b ? a:b)				/* Max(a,b)=max{a,b} */
#define Min(a,b) (a<b ? a:b)				/* Min(a,b)=min{a,b} */
int BCHLdecomp(int n,int lm,double eps,double a[][n1]){
/*  :  ӥ쥹ʬоӹA򥳥쥹ʬ򤹤    */
/*     n:  int             Aμ                                */
/*    lm:  int             Aκ=                   */
/*   eps:  double          Ƚ                         */
/*     a:  double[][]    Aβa[1:n][1:n]     */
/*                                     Aӥ쥹ʬ        */
/*     j:  int*            λ  j=0:                     */
/*                                       j>0:۾A͡      */
	int i,j,k;
	for(j=1;j<=n;j++){
		for(k=Max(1,j-lm);k<j;k++){ 		/* a[j][j]=l[j][j]^2 */
			a[j][j]-=a[j][k]*a[j][k];
			}
		if(a[j][j]<eps){					/* Ƚ */
			return j;						/* ۾ｪλ */
			}
		a[j][j]=sqrt(a[j][j]);				/* a[j][j]=l[j][j] */
		for(i=j+1;i<=Min(n,j+lm);i++){		/* (13) */
			for(k=Max(1,i-lm);k<j;k++){
				a[i][j]-=a[i][k]*a[j][k];
				}
			a[i][j] /=a[j][j];				/* a[i][j]=l[i][j] */
			}
		}
	return 0;								/* ｪλ */
	}
int BCHLsolve(double a[][n1], int n, int lm, double b[]){
/*  :  ӥ쥹Aӥ쥹ʬη̤ѤAx=b*/
/*     a:  double[][]      BCHLdecompνϡAӥ쥹ʬ*/
/*    lm:  int             Aκ=                   */
/*     n:  int             θ                           */
/*     b:  double[]      ե٥ȥb٥ȥx           */
	int i,j;
	for(i=1;i<=n;i++){						/*  */
		for(j=Max(1,i-lm);j<i;j++)b[i]-=a[i][j]*b[j];
		b[i] /=a[i][i];
		}
	for(i=n;i>=1;i--){						/*  */
		for(j=i+1;j<=Min(n,i+lm);j++)b[i]-=a[j][i]*b[j];
		b[i] /=a[i][i];
		}
	return 0;
	}       
int main(){
	double a[n1][n1],b[n1],x[n1],eps;
	int i,j,n,lm,cnd;
	n=n1-1;									/* Aμn */
	lm=1;									/* lm */
	/* xʤβˤʤ褦 */
	for(i=1;i<=n;i++)x[i]=1;
	/* AΤ߷׻*/
	for(j=1;j<=n;j++){
		for(i=j;i<=Min(n,j+lm);i++)a[i][j]=1;
		a[j][j]=n;
		}
	/* ե٥ȥ b=Axʲxˤʤ褦b */ 
	for(i=1;i<=n;i++){
		b[i]=0;
		for(j=Max(1,i-lm);j<i;j++)b[i]+=a[i][j]*x[j];
		for(j=i;j<=Min(n,i+lm);j++)b[i]+=a[j][i]*x[j];
		}
	/* ʲb */
	eps=1.0e-14;
	cnd=BCHLdecomp(n,lm,eps,a);
	printf("cnd=%d\n",cnd);
	BCHLsolve(a, n, lm, b);
	for(i=1;i<=n;i++){
		printf("b[%2d]=%10.7f, error=%9.2e\n",i,b[i],b[i]-x[i]);
		}
	return 0;
	}
