#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define n1 6								/* n1>=n+1, nϹAμ*/
#define Max(a,b) ((a>b)? a:b)				/* Max(a,b)=max{a,b} */
#define Min(a,b) ((a<b)? a:b)				/* Min(a,b)=min{a,b} */
int BLUdecomp(int n,int lm,int rh,double eps,double a[][n1]){
/*  :  LUʬӹALUʬ򤹤                              */
/*     n:  int             Aμ                                */
/*    lm:  int             Aκ                              */
/*    rh:  int             Aα                              */
/*   eps:  double          §Ƚ                         */
/*     a:  double[][]    Aa[1:n][1:n]               */
/*                                             ALUʬ        */
/*   cnd:  int*            λ  cnd=0:                   */
/*                                       cnd>0:۾A§      */
	int i,j,k;
	for(k=1;k<=n;k++){								/* ʾõ */
		if(fabs(a[k][k])<eps){						/* §Ƚ */
			return -k;								/* ۾ｪλ */
			}
		for(i=k+1;i<=Min(k+lm,n);i++){				/* õ */
			a[i][k]=a[i][k]/a[k][k];				/* pεϿ */
			for(j=k+1;j<=Min(k+rh,n);j++){
				a[i][j]-=a[i][k]*a[k][j];
				}
			}
		}
	return 0;										/* ｪλ */
	}
int BLUsolve(double a[][n1], int n, int lm, int rh, double b[]){
/*  :  LUALUʬη̤ѤAx=b                */
/*     a:  double[][]      BLUdecompνϡALUʬ         */
/*    lm:  int             Aκ                              */
/*    rh:  int             Aα                              */
/*     n:  int             θ                           */
/*     b:  double[]      ե٥ȥb[1:n]٥ȥx[1:n] */
	int i,j;
	for(i=2;i<=n;i++){								/*  */
		for(j=Max(1,i-lm);j<=i-1;j++)b[i]-=a[i][j]*b[j];
		}
	for(i=n;i>=1;i--){								/*  */
		for(j=i+1;j<=Min(n,i+rh);j++)b[i]-=a[i][j]*b[j];
		b[i]=b[i]/a[i][i];
		}
	return 0;
		}
        
int main(){
	double a[n1][n1],b[n1],x[n1],eps;
	int i,j,n,lm,rh,cnd;
	n=n1-1;											/* n */
	lm=1;											/* lm */
	rh=1;											/* rh */
	/* xʤβˤʤ褦 */
	for(i=1;i<=n;i++)x[i]=1;
	/* AΤ߷׻*/
	for(i=1;i<=n;i++){
		for(j=Max(1,i-lm);j<=Min(n,i+rh);j++)a[i][j]=1;
		a[i][i]=n;
		}
	/* ե٥ȥbb=AxȤ */ 
	for(i=1;i<=n;i++){
		b[i]=0;
		for(j=Max(1,i-lm);j<=Min(n,i+rh);j++)b[i]+=a[i][j]*x[j];
		}
	/* ʲb */
	eps=1.0e-14;
	cnd=BLUdecomp(n,lm,rh,eps,a);
	printf("cnd=%d\n",cnd);
	BLUsolve(a, n, lm, rh ,b);
	/* for(i=1;i<n;i++)printf("%d %d\n",i,pv[i]); */
	for(i=1;i<=n;i++){
		printf("b[%2d]=%10.7f, error=%9.2e\n",i,b[i],b[i]-x[i]);
		}
	return 0;
	}
